// Nastaveni.cpp : implementation file
//

#include "stdafx.h"
#include "IQPokyd.h"
#include "Nastaveni.h"
#include "text.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNastaveni dialog


CNastaveni::CNastaveni(CWnd* pParent /*=NULL*/)
	: CDialog(CNastaveni::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNastaveni)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CNastaveni::~CNastaveni(void) {
  if (IsWindow(m_hWnd)) DestroyWindow();
 }

void CNastaveni::DoDataExchange(CDataExchange* pDX) {
  CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNastaveni)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
 }

BEGIN_MESSAGE_MAP(CNastaveni, CDialog)
	//{{AFX_MSG_MAP(CNastaveni)
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_ZOBRAZOVATPOPISKY, OnZobrazovatpopisky)
	ON_COMMAND(ID_ZKRATKA_SMAZRADEK, OnClose)
	ON_BN_CLICKED(IDC_POCITACZENA, BublinkovaNapoveda)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_ROZSIRENENASTAVENI, OnRozsireneNastaveni)
	ON_BN_CLICKED(IDC_ZAKLADNINASTAVENI, OnZakladniNastaveni)
	ON_BN_CLICKED(IDC_POCITACMUZ, BublinkovaNapoveda)
	ON_BN_CLICKED(IDC_CLOVEKZENA, BublinkovaNapoveda)
	ON_BN_CLICKED(IDC_CLOVEKMUZ, BublinkovaNapoveda)
	ON_BN_CLICKED(IDC_EMULOVATKLAVESNICI, OnNastavDisableEmulace)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNastaveni message handlers

BOOL CNastaveni::OnHelpInfo(HELPINFO* pHelpInfo) {
	return(TRUE);
 }

BOOL CNastaveni::OnInitDialog() {
  CDialog::OnInitDialog();

  if (g_nastaveni.pohlavicloveka == 1) CheckDlgButton(IDC_CLOVEKMUZ,1);
  else CheckDlgButton(IDC_CLOVEKZENA,1);
  if (g_nastaveni.pohlavipocitace == 1) CheckDlgButton(IDC_POCITACMUZ,1);
  else CheckDlgButton(IDC_POCITACZENA,1);

  GetDlgItem(IDC_JMENOCLOVEKA)->SetWindowText(g_nastaveni.jmenocloveka);
  GetDlgItem(IDC_JMENOPOCITACE)->SetWindowText(g_nastaveni.jmenopocitace);

  SendDlgItemMessage(IDC_CHARAKTER,LB_ADDSTRING,0,(LPARAM)"stroj");
  SendDlgItemMessage(IDC_CHARAKTER,LB_ADDSTRING,0,(LPARAM)"naivn");
  SendDlgItemMessage(IDC_CHARAKTER,LB_ADDSTRING,0,(LPARAM)"klidn");
  SendDlgItemMessage(IDC_CHARAKTER,LB_ADDSTRING,0,(LPARAM)"prmrn");
  SendDlgItemMessage(IDC_CHARAKTER,LB_ADDSTRING,0,(LPARAM)"nedviv");
  SendDlgItemMessage(IDC_CHARAKTER,LB_ADDSTRING,0,(LPARAM)"nladov");
  SendDlgItemMessage(IDC_CHARAKTER,LB_ADDSTRING,0,(LPARAM)"vbun");

  SendDlgItemMessage(IDC_CHARAKTER,LB_SETCURSEL,g_nastaveni.charakter);

  SendDlgItemMessage(IDC_NALADA,LB_ADDSTRING,0,(LPARAM)"vborn");
  SendDlgItemMessage(IDC_NALADA,LB_ADDSTRING,0,(LPARAM)"dobr");
  SendDlgItemMessage(IDC_NALADA,LB_ADDSTRING,0,(LPARAM)"normln");
  SendDlgItemMessage(IDC_NALADA,LB_ADDSTRING,0,(LPARAM)"patn");
  SendDlgItemMessage(IDC_NALADA,LB_ADDSTRING,0,(LPARAM)"hrozn");

  SendDlgItemMessage(IDC_NALADA,LB_SETCURSEL,g_nastaveni.nalada-1);

  CheckDlgButton(IDC_UKLADATROZHOVOR,g_nastaveni.ukladatrozhovor);
  CheckDlgButton(IDC_POUZIVATZVUKY,g_nastaveni.pouzivatzvuky);
  CheckDlgButton(IDC_POUZIVATEFEKTY,g_nastaveni.pouzivatefekty);
  CheckDlgButton(IDC_SPISOVNACESTINA,g_nastaveni.spisovnacestina);

  if (g_nastaveni.emulovatklavesnici > 0)
   CheckDlgButton(IDC_EMULOVATKLAVESNICI,1);
  else 
   CheckDlgButton(IDC_EMULOVATKLAVESNICI,0);

  OnNastavDisableEmulace();

  if (g_nastaveni.emulovatklavesnici == 2)
   CheckDlgButton(IDC_EMULOVATSLOVENSKOUKLAVESNICI,1);
  else
   CheckDlgButton(IDC_EMULOVATCESKOUKLAVESNICI,1);

  CheckDlgButton(IDC_KLAVESNICEQWERTY,g_nastaveni.klavesniceqwerty);
  CheckDlgButton(IDC_ZOBRAZOVATSTANDARDNIKURZOR,g_nastaveni.standardnikurzor);
  CheckDlgButton(IDC_NEZOBRAZOVATPOZADI,g_nastaveni.prikaz_nezobrazovatpozadi);
  CheckDlgButton(IDC_READONLYMOD,g_nastaveni.prikaz_readonlymod);
  CheckDlgButton(IDC_ZOBRAZOVATPOPISKY,g_nastaveni.zobrazovatpopisky);
	

  m_oNapoveda.Create(this);
  if (g_nastaveni.zobrazovatpopisky == 1) m_oNapoveda.Activate(TRUE);
  else m_oNapoveda.Activate(FALSE);
  m_oNapoveda.SendMessage(TTM_SETMAXTIPWIDTH,0,450);
  m_oNapoveda.SendMessage(TTM_SETDELAYTIME,TTDT_AUTOPOP,10000);
  m_oNapoveda.SendMessage(TTM_SETDELAYTIME,TTDT_INITIAL,200);
  m_oNapoveda.SendMessage(TTM_SETDELAYTIME,TTDT_RESHOW,0);

  BublinkovaNapoveda();
  
  OnZakladniNastaveni();

  return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
 }

BOOL CNastaveni::PreTranslateMessage(MSG* pMsg) {
  m_oNapoveda.RelayEvent(pMsg);
  return CDialog::PreTranslateMessage(pMsg);
 }

void CNastaveni::OnOK() {
BYTE docasnanalada,prekreslipozadi=0;
CEdit* pEdit=NULL;
CString jmeno;

  if (IsDlgButtonChecked(IDC_CLOVEKZENA) == 0) g_nastaveni.pohlavicloveka=1;
  else g_nastaveni.pohlavicloveka=2;
  if (IsDlgButtonChecked(IDC_POCITACZENA) == 0) g_nastaveni.pohlavipocitace=1;
  else g_nastaveni.pohlavipocitace=2;

  pEdit = (CEdit*)GetDlgItem(IDC_JMENOCLOVEKA);
  pEdit->GetWindowText(jmeno);
  if (ZKONTROLUJ_SPRAVNOST_ZNAKU_VE_JMENE(jmeno) == 0) {
    MessageBox("Tv jmno mus bt jednoslovn! Sice si vm toho, e se mi pedstavuje i s pjmenm, ale pece jenom je lep na nkoho volat jen kestnm jmnem.","Chyba",MB_ICONWARNING | MB_SYSTEMMODAL);
    pEdit->SetFocus(); return;
   }
  strncpy(g_nastaveni.jmenocloveka,jmeno,MAX_DELKA_JMENA);
  g_nastaveni.jmenocloveka[MAX_DELKA_JMENA]=0;

  pEdit = (CEdit*)GetDlgItem(IDC_JMENOPOCITACE);
  pEdit->GetWindowText(jmeno);
  if (ZKONTROLUJ_SPRAVNOST_ZNAKU_VE_JMENE(jmeno) == 0) {
    MessageBox("M jmno mus bt jednoslovn! Nepotebuji njak dlouh jmno; sta mi jen to kestn.","Chyba",MB_ICONWARNING | MB_SYSTEMMODAL);
    pEdit->SetFocus(); return;
   }
  strncpy(g_nastaveni.jmenopocitace,jmeno,MAX_DELKA_JMENA);
  g_nastaveni.jmenopocitace[MAX_DELKA_JMENA]=0;
  
  g_nastaveni.charakter=(BYTE)SendDlgItemMessage(IDC_CHARAKTER,LB_GETCURSEL,0,0);

  docasnanalada=(BYTE)SendDlgItemMessage(IDC_NALADA,LB_GETCURSEL,0,0)+1;
  if (docasnanalada != g_nastaveni.nalada) {
    g_nastaveni.nalada=docasnanalada; g_nastaveni.SPOCITEJ_NALADABODY_Z_NALADY();
   }

  if (IsDlgButtonChecked(IDC_UKLADATROZHOVOR) == 0) g_nastaveni.ukladatrozhovor=0;
  else g_nastaveni.ukladatrozhovor=1;
  if (IsDlgButtonChecked(IDC_POUZIVATZVUKY) == 0) g_nastaveni.pouzivatzvuky=0;
  else g_nastaveni.pouzivatzvuky=1;
  if (IsDlgButtonChecked(IDC_POUZIVATEFEKTY) == 0) g_nastaveni.pouzivatefekty=0;
  else g_nastaveni.pouzivatefekty=1;
  if (IsDlgButtonChecked(IDC_SPISOVNACESTINA) == 0) g_nastaveni.spisovnacestina=0;
  else g_nastaveni.spisovnacestina=1;

  if (IsDlgButtonChecked(IDC_EMULOVATKLAVESNICI) != 0) {
    if (IsDlgButtonChecked(IDC_EMULOVATCESKOUKLAVESNICI) == 0) g_nastaveni.emulovatklavesnici=2;
    else g_nastaveni.emulovatklavesnici=1;
   }
  else g_nastaveni.emulovatklavesnici=0;
  if (IsDlgButtonChecked(IDC_KLAVESNICEQWERTY) == 0) g_nastaveni.klavesniceqwerty=0;
  else g_nastaveni.klavesniceqwerty=1;
  if (IsDlgButtonChecked(IDC_ZOBRAZOVATSTANDARDNIKURZOR) == 0) g_nastaveni.standardnikurzor=0;
  else g_nastaveni.standardnikurzor=1;
  if (IsDlgButtonChecked(IDC_NEZOBRAZOVATPOZADI) == 0) {
    if (g_nastaveni.prikaz_nezobrazovatpozadi == 1) {
      prekreslipozadi=1; g_nastaveni.prikaz_nezobrazovatpozadi=0;
     }
   }
  else {
    if (g_nastaveni.prikaz_nezobrazovatpozadi == 0) {
      prekreslipozadi=1; g_nastaveni.prikaz_nezobrazovatpozadi=1;
     }
   }
  if (IsDlgButtonChecked(IDC_READONLYMOD) == 0) g_nastaveni.prikaz_readonlymod=0;
  else g_nastaveni.prikaz_readonlymod=1;

  if (IsDlgButtonChecked(IDC_ZOBRAZOVATPOPISKY) == 0) g_nastaveni.zobrazovatpopisky=0;
  else g_nastaveni.zobrazovatpopisky=1;

  ZAPIS_DO_MENU_AKTUALNI_STAV_NASTAVENI();
  NASTAV_VIDITELNOST_EFEKTNICH_PROGRESSBARU();
  if (prekreslipozadi == 1) NASTAV_VIDITELNOST_POZADI(1);
  ZAPIS_NASTAVENI_DO_SOUBORU(g_nastaveni);

  if (g_nastaveni.pouzivatzvuky == 0) PlaySound(NULL, g_instanceprogramu, SND_PURGE);

  CDialog::OnOK();
 }

void CNastaveni::OnZobrazovatpopisky() {
  if (IsDlgButtonChecked(IDC_ZOBRAZOVATPOPISKY) == 0) m_oNapoveda.Activate(FALSE);
  else m_oNapoveda.Activate(TRUE);
 }

void CNastaveni::OnClose() {
  SendMessage(WM_CLOSE);
 }

void CNastaveni::BublinkovaNapoveda() {
static BYTE pohlavicloveka=0,pohlavipocitace=0;

  if (IsDlgButtonChecked(IDC_CLOVEKZENA) == 0) {     //pro musk pohlav
    if (pohlavicloveka == 2) {
      GetDlgItem(IDC_JMENOCLOVEKA)->SetFocus();
       //pokud se zmn pohlav, je teba dt focus i pro zmnu jmna
      SendDlgItemMessage(IDC_JMENOCLOVEKA,EM_SETSEL,0,-1);
     }                            //"nasvcen" jmna
    pohlavicloveka=1;
   }
  else {     //pro ensk pohlav
    if (pohlavicloveka == 1) {
      GetDlgItem(IDC_JMENOCLOVEKA)->SetFocus();
       //pokud se zmn pohlav, je teba dt focus i pro zmnu jmna
      SendDlgItemMessage(IDC_JMENOCLOVEKA,EM_SETSEL,0,-1);
     }                            //"nasvcen" jmna
    pohlavicloveka=2;
   }

  if (IsDlgButtonChecked(IDC_POCITACZENA) == 0) {     //pro musk pohlav
    if (pohlavipocitace == 2) {
      GetDlgItem(IDC_JMENOPOCITACE)->SetFocus();
       //pokud se zmn pohlav, je teba dt focus i pro zmnu jmna
      SendDlgItemMessage(IDC_JMENOPOCITACE,EM_SETSEL,0,-1);
     }                            //"nasvcen" jmna
    pohlavipocitace=1;
   }
  else {     //pro ensk pohlav
    if (pohlavipocitace == 1) {
      GetDlgItem(IDC_JMENOPOCITACE)->SetFocus();
       //pokud se zmn pohlav, je teba dt focus i pro zmnu jmna
      SendDlgItemMessage(IDC_JMENOPOCITACE,EM_SETSEL,0,-1);
     }                            //"nasvcen" jmna
    pohlavipocitace=2;
   }

//  m_oNapoveda.AddTool(GetDlgItem(IDC_CLOVEKPOHLAVI),"Zde si ur, jak m pohlav (ne e by ses musel(a) peoperovat :-) )");
  m_oNapoveda.AddTool(GetDlgItem(IDC_CLOVEKZENA),"Ty (tedy lovk) jsi enskho pohlav");
  m_oNapoveda.AddTool(GetDlgItem(IDC_CLOVEKMUZ),"Ty (tedy lovk) jsi muskho pohlav");
//  m_oNapoveda.AddTool(GetDlgItem(IDC_POCITACPOHLAVI),"Zde ur, jestli mm bt j mu nebo ena");
  m_oNapoveda.AddTool(GetDlgItem(IDC_POCITACZENA),"J (tedy pota) budu ena");
  m_oNapoveda.AddTool(GetDlgItem(IDC_POCITACMUZ),"J (tedy pota) budu chlap");
  m_oNapoveda.AddTool(GetDlgItem(IDC_JMENOPOCITACE),"Sem napi, jak se mm jmenovat j (tedy pota). Jmno nem zsadn vliv na chod programu");

  if (pohlavipocitace == 1) {     //pro musk pohlav
    m_oNapoveda.AddTool(GetDlgItem(IDC_JMENOCLOVEKA),"Sem napi, jak se jmenuje a jak bych t tedy ml oslovovat. Jmno nem zsadn vliv na chod programu");
    m_oNapoveda.AddTool(GetDlgItem(IDC_CHARAKTER),"Podle toho, jak mm charakter, reaguji na hovor a podle toho tak mnm nladu. Pokud nastav jako charakter \"stroj\", budu pod stejn, tedy nladu mnit sm nebudu.");
    m_oNapoveda.AddTool(GetDlgItem(IDC_NALADA),"Nlada ovlivuje moje chovn a podle n se tak chovm. Pozor, nladu sm mnm, ale jakm zpsobem, to udv mj charakter.");
   }
  else {     //pro ensk pohlav
    m_oNapoveda.AddTool(GetDlgItem(IDC_JMENOCLOVEKA),"Sem napi, jak se jmenuje a jak bych t tedy mla oslovovat. Jmno nem zsadn vliv na chod programu");
    m_oNapoveda.AddTool(GetDlgItem(IDC_CHARAKTER),"Podle toho, jak mm charakter, reaguji na hovor a podle toho tak mnm nladu. Pokud nastav jako charakter \"stroj\", budu pod stejn, tedy nladu mnit sama nebudu.");
    m_oNapoveda.AddTool(GetDlgItem(IDC_NALADA),"Nlada ovlivuje moje chovn a podle n se tak chovm. Pozor, nladu sama mnm, ale jakm zpsobem, to udv mj charakter.");
   }
  m_oNapoveda.AddTool(GetDlgItem(IDC_UKLADATROZHOVOR),"Zapsat cel rozhovor pi ukonen programu do souboru "JMENO_SOUBORU_S_TEXTOVYMI_ZAZNAMY" v adresi s IQ Pokydem");

  if (g_tuknuti.aktualnipocetzvuku > 0)
   m_oNapoveda.AddTool(GetDlgItem(IDC_POUZIVATZVUKY),"M-li program pouvat njak zvuky, nebo t tak drsaj, e je mm radji vypnout.");
  else m_oNapoveda.AddTool(GetDlgItem(IDC_POUZIVATZVUKY),"NA TTO HODNOT MOMENTLN VBEC NEZLE, PROTOE SOUBOR \"TUKNUTI.WAV\" CHYB. PROSM NAHRAJ HO K PROGRAMU, DO T DOBY NEMَU DN ZVUKY VYDVAT.\nNebo m jet jinou monost: zkopruj jako \"tuknuti.wav\" njak vlastn krtk WAVE soubor. Pokud to bude standardn .wav (hlavika 44 bajt), 8bitov, mono, budu ho pouvat v rznch frekvencch.");

  m_oNapoveda.AddTool(GetDlgItem(IDC_POUZIVATEFEKTY),"Mm-li pouvat pi bhu programu rzn grafick efekty (konkrtn dva progress bary po stranch).");
  m_oNapoveda.AddTool(GetDlgItem(IDC_SPISOVNACESTINA),"M-li se dvat pednost spisovn etin ped hovorovou etinou.\nZatrhnut tohoto tlatka neznamen plnou spisovnost programu, ale bude \"o tdu\" spisovnj. Vzhledem k mmu celkovmu hovorovmu zpsobu vyjadovn tak ale mou vzniknout bizardn konstrukce, kter by nikdo normln neekl.\nV opanm ppad budu pouvat spe hovorovou etinu.");

  m_oNapoveda.AddTool(GetDlgItem(IDC_EMULOVATKLAVESNICI),"Pi zakrnut tto volby se bude program chovat, jako kdyby byla na potai nainstalovna a aktivn esk (slovensk) klvesnice. Tedy msto sel budou znaky s diakritikou, budou i jinak nkter speciln znaky (otaznk, vykink atd.).\nEmulace se tk i zkladnch psmen bez diakritiky (kter u nkterch exotitjch jazyk mou bt zpehzen).");
  m_oNapoveda.AddTool(GetDlgItem(IDC_EMULOVATCESKOUKLAVESNICI),"Emulovat standardn eskou klvesnici.\nPokud nechce prohazovat psmena Y a Z, zakrtni i volbu \"QWERTY\".");
  m_oNapoveda.AddTool(GetDlgItem(IDC_EMULOVATSLOVENSKOUKLAVESNICI),"Emulovat standardn slovenskou klvesnici. Je vylepen (po vzoru esk klvesnice) o automatick psan velkch psmen i s diakritikou pi zapnutm CapsLocku.\nPokud nechce prohazovat psmena Y a Z, zakrtni i volbu \"QWERTY\".");
  m_oNapoveda.AddTool(GetDlgItem(IDC_KLAVESNICEQWERTY),"Chce-li uspodn zkladn klvesnice tak, jako je na anglick klvesnici (tedy prvn ada zan Q, W, E, R, T, Y), zakrtni tuto volbu. Chce-li oproti anglick klvesnici prohodit psmena Z a Y (tedy prvn ada bude zanat Q, W, E, R, T, Z), nech tuto volbu nezakrtnutou.\nStandardn uspodn esk i slovensk klvesnice je QWERTZ (tedy nezakrtl).");
  m_oNapoveda.AddTool(GetDlgItem(IDC_ZOBRAZOVATSTANDARDNIKURZOR),"M-li se zobrazovat standardn kurzor pouvan v textovch polkch ve Windows, tedy svisl rka (|).\nPi nezakrtnut tohoto polka se pouije kurzor znm z DOSu ve tvaru podtrtka (_).");
  m_oNapoveda.AddTool(GetDlgItem(IDC_NEZOBRAZOVATPOZADI),"Mm-li nebo nemm zobrazovat pozad okna a polek, do kterch se pe.\nTuto volbu zakrtni, kdy:\n1) Pe lutm psmem na blm pozad\n2) Pozad samotnch oken je jen zm barev a nen pes to podn vidt\nTato volba je vlastn korekc nedoeench problm programu. V prbhu ptch verz by se mly tyto problmy (snad) vyeit a tato volba potom zmiz.\n\nPozn.: Tato volba lze tak zapnout u pi sputn programu. Spus program z pkazovho dku parametrem \"-bezpozadi\", tedy \"IQPokyd.exe -bezpozadi\".");
  if (pohlavipocitace == 1) {     //pro musk pohlav
    m_oNapoveda.AddTool(GetDlgItem(IDC_READONLYMOD),"Pokud z njakho dvodu nechce, abych cokoli zapisoval na disk (pojmem \"na disk\" rozumj do toho adrese, kde jsem j sm), pak zakrtni tuto volbu. V praxi to vyuije nap. kdy m bude chtt spoutt z CD atd. (ovem tuto volbu mus zakrtnout jet pedtm, ne m vypl, nastaven taky ukldm k sob do adrese!).\n\nPozn.: Tato volba lze tak zapnout u pi sputn programu. Spus program z pkazovho dku parametrem \"-readonly\", tedy \"IQPokyd.exe -readonly\".");
   }
  else {     //pro ensk pohlav
    m_oNapoveda.AddTool(GetDlgItem(IDC_READONLYMOD),"Pokud z njakho dvodu nechce, abych cokoli zapisoval na disk (pojmem \"na disk\" rozumj do toho adrese, kde jsem j sama), pak zakrtni tuto volbu. V praxi to vyuije nap. kdy m bude chtt spoutt z CD atd. (ovem tuto volbu mus zakrtnout jet pedtm, ne m vypl, nastaven taky ukldm k sob do adrese!).\n\nPozn.: Tato volba lze tak zapnout u pi sputn programu. Spus program z pkazovho dku parametrem \"-readonly\", tedy \"IQPokyd.exe -readonly\".");
   }
  m_oNapoveda.AddTool(GetDlgItem(IDC_ZOBRAZOVATPOPISKY),"");

  m_oNapoveda.AddTool(GetDlgItem(IDC_ZOBRAZOVATPOPISKY),"M-li se zobrazovat tato bublinkov npovda...");
  m_oNapoveda.AddTool(GetDlgItem(IDOK),"Potvrdit nastaven a uloit");
  m_oNapoveda.AddTool(GetDlgItem(IDCANCEL),"Radi nechat pvodn nastaven");
 }

HBRUSH CNastaveni::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) {
  pDC->SetBkMode(TRANSPARENT);
  if (nCtlColor == CTLCOLOR_EDIT || nCtlColor == CTLCOLOR_LISTBOX) {
    return CDialog::OnCtlColor(pDC,pWnd,nCtlColor); 
   }
  return g_stetecpozadipodokna;
 }

void ZOBRAZ_NA_DIALOGU_POLICKO(CWnd *policko,BYTE zobraz) {
   //zobrazi (zobraz=1) nebo skryje (zobraz=0) policko,
   //a to vcetne klavesove asociace.
int pozice;
char *text=ALOKUJ_RETEZEC(1001);

  switch(zobraz) {
    case 0: policko->ShowWindow(SW_HIDE); break;
    case 1: policko->ShowWindow(SW_SHOW); break;
    default: NAHLAS_CHYBU(__FILE__,__LINE__,_NESPECIFIKOVANO_,_UKONCIT_);
   }

  policko->GetWindowText(text,1000);
  for (pozice=0; text[pozice] != 0; pozice++) {
    if (pozice == 1000) NAHLAS_CHYBU(__FILE__,__LINE__,_NESPECIFIKOVANO_,_UKONCIT_);
    if (text[pozice] == '~' && zobraz == 1) text[pozice]='&';
    if (text[pozice] == '&' && zobraz == 0) text[pozice]='~';
   }
  policko->SetWindowText(text);

  UVOLNI(text);
 }

void CNastaveni::OnZakladniNastaveni() {
  SetFocus();

/*  CTabCtrl *zalozky;
  zalozky=(CTabCtrl *)GetDlgItem(IDC_ZALOZKY);
  zalozky->InsertItem(0,"Zkladn nastaven");
  zalozky->InsertItem(1,"Rozen nastaven");*/

  ((CButton *)GetDlgItem(IDC_ZAKLADNINASTAVENI))->SetState(TRUE);
  ((CButton *)GetDlgItem(IDC_ROZSIRENENASTAVENI))->SetState(FALSE);

  GetDlgItem(IDC_RAMECEK1)->SetWindowText("Nae charakteristiky");
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_CLOVEKPOHLAVI),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_POCITACPOHLAVI),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_CLOVEKZENA),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_POCITACZENA),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_CLOVEKMUZ),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_POCITACMUZ),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_JMENOCLOVEKASTATIC),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_JMENOPOCITACESTATIC),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_JMENOCLOVEKA),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_JMENOPOCITACE),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_CHARAKTERSTATIC),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_NALADASTATIC),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_CHARAKTER),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_NALADA),1);

  GetDlgItem(IDC_RAMECEK2)->SetWindowText("Prosted");
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_UKLADATROZHOVOR),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_POUZIVATZVUKY),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_POUZIVATEFEKTY),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_SPISOVNACESTINA),1);

  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_EMULOVATKLAVESNICI),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_EMULOVATCESKOUKLAVESNICI),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_EMULOVATSLOVENSKOUKLAVESNICI),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_KLAVESNICEQWERTY),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_TEXTKEMULACI),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_ZOBRAZOVATSTANDARDNIKURZOR),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_NEZOBRAZOVATPOZADI),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_READONLYMOD),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_ZOBRAZOVATPOPISKY),0);
 }

void CNastaveni::OnRozsireneNastaveni() {
  SetFocus();

/*  CTabCtrl *zalozky;
  zalozky=(CTabCtrl *)GetDlgItem(IDC_ZALOZKY);
  zalozky->InsertItem(0,"Zkladn nastaven");
  zalozky->InsertItem(1,"Rozen nastaven");
*/

  ((CButton *)GetDlgItem(IDC_ZAKLADNINASTAVENI))->SetState(FALSE);
  ((CButton *)GetDlgItem(IDC_ROZSIRENENASTAVENI))->SetState(TRUE);

  GetDlgItem(IDC_RAMECEK1)->SetWindowText("Emulace prosted");
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_CLOVEKPOHLAVI),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_POCITACPOHLAVI),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_CLOVEKZENA),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_POCITACZENA),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_CLOVEKMUZ),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_POCITACMUZ),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_JMENOCLOVEKASTATIC),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_JMENOPOCITACESTATIC),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_JMENOCLOVEKA),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_JMENOPOCITACE),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_CHARAKTERSTATIC),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_NALADASTATIC),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_CHARAKTER),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_NALADA),0);

  GetDlgItem(IDC_RAMECEK2)->SetWindowText("Jin nastaven");
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_UKLADATROZHOVOR),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_POUZIVATZVUKY),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_POUZIVATEFEKTY),0);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_SPISOVNACESTINA),0);

  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_EMULOVATKLAVESNICI),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_EMULOVATCESKOUKLAVESNICI),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_EMULOVATSLOVENSKOUKLAVESNICI),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_KLAVESNICEQWERTY),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_TEXTKEMULACI),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_ZOBRAZOVATSTANDARDNIKURZOR),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_NEZOBRAZOVATPOZADI),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_READONLYMOD),1);
  ZOBRAZ_NA_DIALOGU_POLICKO(GetDlgItem(IDC_ZOBRAZOVATPOPISKY),1);
 }

void CNastaveni::OnNastavDisableEmulace() {
  if (IsDlgButtonChecked(IDC_EMULOVATKLAVESNICI) == 1) {
    GetDlgItem(IDC_EMULOVATCESKOUKLAVESNICI)->EnableWindow(TRUE);
    GetDlgItem(IDC_EMULOVATSLOVENSKOUKLAVESNICI)->EnableWindow(TRUE);
    GetDlgItem(IDC_KLAVESNICEQWERTY)->EnableWindow(TRUE);
   }
  else {
    GetDlgItem(IDC_EMULOVATCESKOUKLAVESNICI)->EnableWindow(FALSE);
    GetDlgItem(IDC_EMULOVATSLOVENSKOUKLAVESNICI)->EnableWindow(FALSE);
    GetDlgItem(IDC_KLAVESNICEQWERTY)->EnableWindow(FALSE);
   }
 }

